#include <Adafruit_NeoPixel.h>

// Parameter 3 = pixel type flags, add together as needed:
#define PIN 1
#define NUM_PIX 31
Adafruit_NeoPixel strip = Adafruit_NeoPixel(NUM_PIX, PIN, NEO_GRB + NEO_KHZ800);
unsigned int i;
void setup()
{
  pinMode(0, OUTPUT);
  pinMode(2, OUTPUT);
  strip.begin();
  strip.show();
  Serial.begin(9600);
}

void loop()
{
  digitalWrite(0, HIGH);
  digitalWrite(2, LOW);
  for (i = 0; i < 5; i++) {
    rainbow(20);
  }
}

void rainbow(uint8_t wait)
{
  uint16_t i, j;

  strip.setBrightness(255);
  for (j = 0; j < 256; j++) {
    for (i = 0; i < strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((i + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos)
{
  strip.setBrightness(255);
  WheelPos = 255 - WheelPos;
  if (WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } else if (WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  } else {
    WheelPos -= 170;
    return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  }
}
